#![allow(bad_style)]
#![allow(clippy::float_cmp)]

use hektor::*;

#[test]
fn Quat_mul() {
  let q1 = Quat::new(1.0, 0.0, 1.0, 0.0);
  assert_eq!(q1 * q1, Quat::new(0.0, 0.0, 2.0, 0.0));
  //
  let q2 = Quat::new(1.0, 0.5, 0.5, 0.75);
  assert_eq!(q1 * q2, Quat::new(0.5, 1.25, 1.5, 0.25));
}

#[test]
fn Quat_mul_assign() {
  let mut q1 = Quat::new(1.0, 0.0, 1.0, 0.0);
  q1 *= q1;
  assert_eq!(q1, Quat::new(0.0, 0.0, 2.0, 0.0));
  //
  let mut q1 = Quat::new(1.0, 0.0, 1.0, 0.0);
  let q2 = Quat::new(1.0, 0.5, 0.5, 0.75);
  q1 *= q2;
  assert_eq!(q1, Quat::new(0.5, 1.25, 1.5, 0.25));
}
